// CommandPool class header
#pragma once

#include "GraphicsResource.h"

namespace nf::client::render {
    class CommandPool : GraphicsResource {
    public:
        CommandPool(const VkDevice& device, const VkQueue& queue, uint32_t queueFamilyIndex);

        VkCommandBuffer allocateCommandBuffer() const;

        VkCommandBuffer beginOneTimeExecution() const;
        void endOneTimeExecution(VkCommandBuffer commandBuffer) const;

        ~CommandPool();
    private:
        const VkQueue& m_queue;

        VkCommandPool m_handle;
    };
}
